#include <iostream>
#include <vector>
#include <unordered_set>
using std::cin;
using std::cout;

int main()
{
    std::ios::sync_with_stdio(false);
    cout.tie(NULL);
    cin.tie(NULL);

    int N, Q, L, R;
    cin >> N;
    std::vector<int> brojevi(N);
    std::unordered_set<int> nesortirani;
    for (int i = 0; i < N; i++) {
        cin >> brojevi[i];
    }

    //trazenje svih nesortiranih brojeva
    for (int i = 1; i < N - 1; i += 2) {
        if (brojevi[i] < brojevi[i - 1]) {
            nesortirani.insert(i - 1);
        }
        if (brojevi[i + 1] < brojevi[i]) {
            nesortirani.insert(i);
        }
    }

    cin >> Q;
    for (int i = 0; i < Q; i++) {
        cin >> L >> R;
        unsigned int br = 0;
        for (auto k = L-1; k < R-1 && br < 2; k++) {
            if (nesortirani.find(k) != nesortirani.end()) {
                br++;
            }
        }
        cout << (br == 2 ? "NE" : "DA") << '\n';
    }
}